// https://github.com/johnwalley/d3-tube-map/ v1.3.0 Copyright 2020 John Walley
!function(t,r){"object"==typeof exports&&"undefined"!=typeof module?r(exports,require("d3")):"function"==typeof define&&define.amd?define(["exports","d3"],r):r((t="undefined"!=typeof globalThis?globalThis:t||self).d3=t.d3||{},t.d3)}(this,(function(t,r){"use strict";const n={N:[0,1],NE:[1,1],E:[1,0],SE:[1,-1],S:[0,-1],SW:[-1,-1],W:[-1,0],NW:[-1,1]};function e(t,r){return t[0]*r[1]-t[1]*r[0]}function o(t,r){return t[0]*r[0]+t[1]*r[1]}function i(t,r){return 0==e(t,r)&&Math.sign(t[0])==Math.sign(r[0])&&Math.sign(t[1])==Math.sign(r[1])}function a(t){return[0,1].map(r=>t(r))}function s(t){let r=function(t){return Math.sqrt(t[0]*t[0]+t[1]*t[1])}(t);return a(n=>t[n]/r)}function l(t){let r=t.toUpperCase();if(!n.hasOwnProperty(r)){let t=Object.keys(n).join(", ");throw new Error(`'${r}' is not a recognised compass bearing. Options are ${t}`)}return n[r]}function f(t){let r=Object.entries(n).find(([r,n])=>i(n,t));if(void 0===r)throw new Error(`No compass bearing matches vector ${t}. Only 45 deg angles are supported.`);return r[0]}function c(t){return`M${t[0]},${t[1]}`}function h(t,r){return`Q${t[0]},${t[1]},${r[0]},${r[1]}`}function d(t){for(let r=1;r<t.nodes.length;r++){let n=t.nodes[r],e=t.nodes[r-1],o=a(t=>Math.round(n.coords[t])-Math.round(e.coords[t])),[s,c]=o;if(0==s&&0==c)throw new Error("Repeated coordinates "+n.coords);if(1==r&&(e.dir=f(o)),i(l(e.dir),o)){if(n.dir=f(o),n.dir!==e.dir)throw new Error(`Direction discontinuity: ${n.coords} is not ${e.dir} of ${e.coords}`)}else{if(!(1==Math.abs(s)&&1==Math.abs(c)||1==Math.abs(s)&&2==Math.abs(c)||2==Math.abs(s)&&1==Math.abs(c)))throw new Error(`Cannot draw a corner between coordinates ${e.coords} and ${n.coords}`);{let t=l(e.dir),r=a(r=>o[r]-t[r]);n.dir=f(r)}}}}function u(t,r,n,e,o){let i="",f=Math.abs(r(1)-r(0)!=0?r(1)-r(0):n(1)-n(0)),d=function(t,r,n,e,o=0,i=[0,0]){let a=n/e;return(n,e,s=0)=>[t(n[0]+s*e[0]+a*(i[0]+o*e[1])),r(n[1]+s*e[1]+a*(i[1]-o*e[0]))]}(r,n,e,f,t.shiftNormal,t.shiftCoords),u=e/(2*o*f);for(let r=1;r<t.nodes.length;r++){let n=t.nodes[r-1],e=t.nodes[r],o=l(n.dir),f=l(e.dir),m=s(o),b=s(f);if(1==r){i+=c(d(n.coords,m,-u))}let g=d(n.coords,m),y=d(e.coords,b,r===t.nodes.length-1?u:0);if(e.dir!==n.dir){i+=h(a(t=>(g[t]*f[t]+y[t]*o[t])/(o[t]+f[t])),y)}else i+=`L${(p=y)[0]},${p[1]}`}var p;return i}function p(t){this.lines=t}function m(t){this.stations=t}m.prototype.toArray=function(){var t=[];for(var r in this.stations)if(this.stations.hasOwnProperty(r)){var n=this.stations[r];n.name=r,t.push(n)}return t},m.prototype.interchanges=function(){return this.toArray().filter((function(t){return"interchange"===t.marker[0].marker}))},m.prototype.normalStations=function(){var t=this.toArray().filter((function(t){return"interchange"!==t.marker[0].marker})),r=[];return t.forEach((function(t){t.marker.forEach((function(n){r.push({name:t.name,line:n.line,x:t.x,y:t.y,color:n.color,dir:n.dir,shiftX:n.shiftX,shiftY:n.shiftY,shiftNormal:n.shiftNormal,labelPos:t.labelPos})}))})),r},t.tubeMap=function(){var t,n,f,c,h={top:80,right:80,bottom:20,left:80},b=760,g=640,y=r.scaleLinear(),v=r.scaleLinear(),w=r.dispatch("click");function x(p){p.each((function(m){f=function(t){t.lines.forEach(t=>d(t)),void 0!==t.river&&d(t.river);return{raw:t.lines,river:t.river,stations:M(t),lines:k(t.lines)}}(m);var x,C,O=r.min(f.raw,(function(t){return r.min(t.nodes,(function(t){return t.coords[0]}))}))-1,E=r.max(f.raw,(function(t){return r.max(t.nodes,(function(t){return t.coords[0]}))}))+1,S=r.min(f.raw,(function(t){return r.min(t.nodes,(function(t){return t.coords[1]}))}))-1,$=r.max(f.raw,(function(t){return r.max(t.nodes,(function(t){return t.coords[1]}))}))+1,A=(E-O)/($-S),X=(b-h.left-h.right)/(g-h.top-h.bottom),Y=X/A;A>X?(x=b-h.left-h.right,C=(g-h.top-h.bottom)*Y):(x=(b-h.left-h.right)/Y,C=g-h.top-h.bottom),y.domain([O,E]).range([h.left,h.left+x]),v.domain([S,$]).range([h.top+C,h.top]);var j=Math.abs(y(1)-y(0)!=0?y(1)-y(0):v(1)-v(0));t=.8*j,n=p.append("svg").style("width","100%").style("height","100%"),c=n.append("g"),void 0!==f.river&&c.append("g").attr("class","river").selectAll("path").data([f.river]).enter().append("path").attr("d",(function(r){return u(r,y,v,t,1.5)})).attr("stroke","#CCECF4").attr("fill","none").attr("stroke-width",1.8*t),c.append("g").attr("class","lines").selectAll("path").data(f.lines.lines).enter().append("path").attr("d",(function(r){return u(r,y,v,t,1.5)})).attr("id",(function(t){return t.name})).attr("stroke",(function(t){return t.color})).attr("fill","none").attr("stroke-width",(function(r){return r.highlighted?1.3*t:t})).classed("line",!0),c.append("g").attr("class","interchanges").selectAll("path").data(f.stations.interchanges()).enter().append("g").attr("id",(function(t){return t.name})).on("click",(function(){var t=r.select(this).attr("id");w.call("click",this,t)})).append("path").attr("d",function(t){return r.arc().innerRadius(0).outerRadius(1.25*t).startAngle(0).endAngle(2*Math.PI)}(t)).attr("transform",(function(t){let r=function(t){let r,n;if(t.forEach(t=>{let e=s(l(t.dir));if(void 0===r)r={vector:e,shiftMin:t.shiftNormal,shiftMax:t.shiftNormal};else if(i(r.vector,e)){let n=o(e,r.vector);r.shiftMin=Math.min(r.shiftMin,t.shiftNormal*n),r.shiftMax=Math.max(r.shiftMax,t.shiftNormal*n)}else if(void 0===n)n={vector:e,shiftMin:t.shiftNormal,shiftMax:t.shiftNormal};else if(i(n.vector,e)){let r=o(e,n.vector);n.shiftMin=Math.min(n.shiftMin,t.shiftNormal*r),n.shiftMax=Math.max(n.shiftMax,t.shiftNormal*r)}}),void 0===r)return[0,0];if(void 0===n){let t=(r.shiftMin+r.shiftMax)/2;return[t*r.vector[1],-t*r.vector[0]]}{let t=e(r.vector,n.vector),o=(r.shiftMin+r.shiftMax)/2,i=(n.shiftMin+n.shiftMax)/2;return a(e=>(i*r.vector[e]-o*n.vector[e])/t)}}(t.marker);return"translate("+y(t.x+.8*(r[0]+t.marker[0].shiftX))+","+v(t.y+.8*(r[1]+t.marker[0].shiftY))+")"})).attr("stroke-width",t/2).attr("fill",(function(t){return t.visited?"#000000":"#ffffff"})).attr("stroke",(function(t){return t.visited?"#ffffff":"#000000"})).classed("interchange",!0).style("cursor","pointer"),c.append("g").attr("class","stations").selectAll("path").data(f.stations.normalStations()).enter().append("g").attr("id",(function(t){return t.name})).on("click",(function(){var t=r.select(this).attr("id");w.call("click",this,t)})).append("path").attr("d",(function(t){return function(t,n,e,o,i){let a=r.line().x((function(t){return n(t[0])})).y((function(t){return e(t[1])})),f=s(l(t.dir)),c=s(l(t.labelPos)),h=t.shiftX+t.shiftNormal*f[1],d=t.shiftY-t.shiftNormal*f[0];return a([[t.x+h*o+o/2.05*c[0],t.y+d*o+o/2.05*c[1]],[t.x+h*o+o/2*c[0]+o/i*c[0],t.y+d*o+o/2*c[1]+o/i*c[1]]])}(t,y,v,.8,1.5)})).attr("stroke",(function(t){return t.color})).attr("stroke-width",t/1.5).attr("fill","none").attr("class",(function(t){return t.line})).attr("id",(function(t){return t.name})).classed("station",!0),c.append("g").attr("class","labels").selectAll("text").data(f.stations.toArray()).enter().append("g").attr("id",(function(t){return t.name})).classed("label",!0).on("click",(function(){var t=r.select(this).attr("id");w.call("click",this,t)})).append("text").text((function(t){return t.label})).attr("fill","#10137E").attr("dy",0).attr("x",(function(t){let r=t.labelShiftX+t.labelShiftNormal*s(l(t.dir))[1];return y(t.x+.8*r)+N(t).pos[0]})).attr("y",(function(t){let r=t.labelShiftY-t.labelShiftNormal*s(l(t.dir))[0];return v(t.y+.8*r)-N(t).pos[1]})).attr("text-anchor",(function(t){return N(t).textAnchor})).style("display",(function(t){return!0!==t.hide?"block":"none"})).style("text-decoration",(function(t){return t.closed?"line-through":"none"})).style("font-size",1.96*t+"px").style("-webkit-user-select","none").attr("class",(function(t){return t.marker.map((function(t){return t.line})).join(" ")})).classed("highlighted",(function(t){return t.visited})).call(P,(function(t){return N(t).alignmentBaseline}))}))}function M(t){return t.lines.forEach((function(r){for(var n=0;n<r.nodes.length;n++){var e=r.nodes[n];if(e.hasOwnProperty("name")){if(!t.stations.hasOwnProperty(e.name))throw new Error("Cannot find station with key: "+e.name);var o=t.stations[e.name];o.x=e.coords[0],o.y=e.coords[1],(void 0===o.labelPos||e.hasOwnProperty("canonical"))&&(o.labelPos=e.labelPos,o.labelShiftX=e.hasOwnProperty("labelShiftCoords")?e.labelShiftCoords[0]:e.hasOwnProperty("shiftCoords")?e.shiftCoords[0]:r.shiftCoords[0],o.labelShiftY=e.hasOwnProperty("labelShiftCoords")?e.labelShiftCoords[1]:e.hasOwnProperty("shiftCoords")?e.shiftCoords[1]:r.shiftCoords[1],o.labelShiftNormal=r.hasOwnProperty("shiftNormal")?r.shiftNormal:0,o.dir=e.dir),o.label=t.stations[e.name].label,o.position=t.stations[e.name].position,o.closed=!!t.stations[e.name].hasOwnProperty("closed")&&t.stations[e.name].closed,o.visited=!1,e.hide||(o.marker=o.marker||[],o.marker.push({line:r.name,color:r.color,labelPos:e.labelPos,dir:e.dir,marker:e.hasOwnProperty("marker")?e.marker:"station",shiftX:e.hasOwnProperty("shiftCoords")?e.shiftCoords[0]:r.shiftCoords[0],shiftY:e.hasOwnProperty("shiftCoords")?e.shiftCoords[1]:r.shiftCoords[1],shiftNormal:r.hasOwnProperty("shiftNormal")?r.shiftNormal:0}))}}})),new m(t.stations)}function k(t){var r=[];return t.forEach((function(t){var n={name:t.name,title:t.label,stations:[],color:t.color,shiftCoords:t.shiftCoords,shiftNormal:t.shiftNormal,nodes:t.nodes,highlighted:!1};r.push(n);for(var e=0;e<t.nodes.length;e++){var o=t.nodes[e];o.hasOwnProperty("name")&&n.stations.push(o.name)}})),function(t){return new p(t)}(r)}function N(r){var n,e,o,i=1.8*t,a=r.label.split(/\n/).length,s=Math.sqrt(2);switch(r.labelPos.toLowerCase()){case"n":n=[0,2.1*t*(a-1)+i],e="middle",o="baseline";break;case"ne":n=[i/s,(t*(a-1)+i)/s],e="start",o="baseline";break;case"e":n=[i,0],e="start",o="middle";break;case"se":n=[i/s,-i/s],e="start",o="hanging";break;case"s":n=[0,-.8*i],e="middle",o="hanging";break;case"sw":n=[-i/s,-i/s],e="end",o="hanging";break;case"w":n=[-i,0],e="end",o="middle";break;case"nw":n=[-(t*(a-1)+i)/s,(t*(a-1)+i)/s],e="end",o="baseline"}return{pos:n,textAnchor:e,alignmentBaseline:o}}function P(t,n){t.each((function(){var t=r.select(this),e=t.text().split(/\n/),o=t.attr("y"),i=t.attr("x"),a=parseFloat(t.attr("dy"));t.text(null).append("tspan").attr("x",i).attr("y",o).attr("dy",a+"em").attr("dominant-baseline",n).text(e[0]);for(var s=1;s<e.length;s++)t.append("tspan").attr("x",i).attr("y",o).attr("dy",1.1*s+a+"em").attr("dominant-baseline",n).text(e[s])}))}return x.width=function(t){return arguments.length?(b=t,x):b},x.height=function(t){return arguments.length?(g=t,x):g},x.margin=function(t){return arguments.length?(h=t,x):h},x.on=function(){var t=w.on.apply(w,arguments);return t===w?x:t},x},Object.defineProperty(t,"__esModule",{value:!0})}));
